
-- variables de type FONCTION --
function ActiveMonstre(nombre)
   if nombre == 1 then
      if not monstre1.ok then
         tmr1:start()
         if tmr1:time() >= 1000 then
            monstre1.x = math.random(256 - monstre1.largeur)
            monstre1.y = math.random(192 - monstre1.hauteur)
            monstre1.ok = true
         end
      end
      elseif nombre == 2 then
         if not monstre2.ok then
            tmr2:start()
            if tmr2:time() >= 1000 then
               monstre2.x = math.random(256 - monstre2.largeur)
               monstre2.y = math.random(192 - monstre2.hauteur)
               monstre2.ok = true
            end
         end
     elseif nombre == 3 then
         if not monstre3.ok then
            tmr3:start()
            if tmr3:time() >= 1000 then
               monstre3.x = math.random(256 - monstre3.largeur)
               monstre3.y = math.random(192 - monstre3.hauteur)
               monstre3.ok = true
            end
         end
     elseif nombre == 4 then
         if not monstre4.ok then
            tmr4:start()
            if tmr4:time() >= 1000 then
               monstre4.x = math.random(256 - monstre4.largeur)
               monstre4.y = math.random(192 - monstre4.hauteur)
               monstre4.ok = true
            end
         end
     elseif nombre == 5 then
         if not monstre5.ok then
            tmr5:start()
            if tmr5:time() >= 1000 then
               monstre5.x = math.random(256 - monstre5.largeur)
               monstre5.y = math.random(192 - monstre5.hauteur)
               monstre5.ok = true
            end
         end
     elseif nombre == 6 then
         if not monstre6.ok then
            tmr6:start()
            if tmr6:time() >= 1000 then
               monstre6.x = math.random(256 - monstre6.largeur)
               monstre6.y = math.random(192 - monstre6.hauteur)
               monstre6.ok = true
            end
         end
   end
end

function ReinitialiseGame()
   cible.x = 256/2 - (cible.largeur/2)   
   cible.y = 192/2 - (cible.hauteur/2)
   
   monstre1.ok = false
   monstre2.ok = false
   monstre3.ok = false
   monstre4.ok = false
   monstre5.ok = false
   monstre6.ok = false
   
   malus = true
  
   score = 0
   munitions = 50
   explosion.ok = false
   
   son.perdu = true   
   son.victoire = true   
   son.croq = true  
         
   if victoire then          
      Image.destroy(victoireImage)
      victoireImage = nil
      victoire = false
      elseif perdu then
         Image.destroy(perduImage)   
         perduImage = nil
         perdu = false
   end
   
   victoireAffichage = true   
   perduAffichage = true   
      
   tmr1:reset()
   tmr1:stop()   
   tmr2:reset()
   tmr2:stop()
   tmr3:reset()
   tmr3:stop()
   tmr4:reset()
   tmr4:stop()
   tmr5:reset()
   tmr5:stop()
   tmr6:reset()
   tmr6:stop()
   
   tmr:reset()
   tmr:start()
end
   
-- VARIABLES --
cible = {}
   cible.image = Image.load("images/cible.png",VRAM)
   cible.largeur = Image.width(cible.image)
   cible.hauteur = Image.height(cible.image)
   cible.x = 256/2 - (cible.largeur/2)   
   cible.y = 192/2 - (cible.hauteur/2)   
   cible.vitesse = 2

monstre1 = {}
   monstre1.image = Image.load("images/monstre1.png",VRAM)
   monstre1.largeur = Image.width(monstre1.image)
   monstre1.hauteur = Image.height(monstre1.image)
   monstre1.x = math.random(256 - monstre1.largeur)
   monstre1.y = math.random(192 - monstre1.hauteur)
   monstre1.ok = false  
         
monstre2 = {}
   monstre2.image = Image.load("images/monstre2.png",VRAM)
   monstre2.largeur = Image.width(monstre2.image)
   monstre2.hauteur = Image.height(monstre2.image)
   monstre2.x = math.random(256 - monstre2.largeur)
   monstre2.y = math.random(192 - monstre2.hauteur)
   monstre2.ok = false 

monstre3 = {}
   monstre3.image = Image.load("images/monstre3.png",VRAM)
   monstre3.largeur = Image.width(monstre3.image)
   monstre3.hauteur = Image.height(monstre3.image)
   monstre3.x = math.random(256 - monstre3.largeur)
   monstre3.y = math.random(192 - monstre3.hauteur)
   monstre3.ok = false  

monstre4 = {}
   monstre4.image = Image.load("images/monstre4.png",VRAM)
   monstre4.largeur = Image.width(monstre4.image)
   monstre4.hauteur = Image.height(monstre4.image)
   monstre4.x = math.random(256 - monstre4.largeur)
   monstre4.y = math.random(192 - monstre4.hauteur)
   monstre4.ok = false 

monstre5 = {}
   monstre5.image = Image.load("images/monstre5.png",VRAM)
   monstre5.largeur = Image.width(monstre5.image)
   monstre5.hauteur = Image.height(monstre5.image)
   monstre5.x = math.random(256 - monstre5.largeur)
   monstre5.y = math.random(192 - monstre5.hauteur)
   monstre5.ok = false

monstre6 = {}
   monstre6.image = Image.load("images/monstre6.png",VRAM)
   monstre6.largeur = Image.width(monstre6.image)
   monstre6.hauteur = Image.height(monstre6.image)
   monstre6.x = math.random(256 - monstre6.largeur)
   monstre6.y = math.random(192 - monstre6.hauteur)
   monstre6.ok = false
         
explosion = {} 
   explosion.image = Image.load("images/explosion.png",VRAM)
   explosion.x = 0
   explosion.y = 0
   explosion.ok = false
      
son = {}   
   son.perdu = true   
   son.victoire = true   -- Pas encore implment   
   son.croq = true   
         
background = Image.load("images/background.jpg",VRAM)

victoire = false
victoireAffichage = true  -- pour grer le chargement de l'image de victoire dans la boucle de jeu : solution pour contourner le manque de VRAM.

perdu = false
perduAffichage = true -- idem que victoireAffichage

munitions = 50
   
score = 0
malus = true  -- pour grer la diminution du score en cas de dfaite

Sound.loadBank("sons/soundbank.bin")
Sound.loadSFX(0)
Sound.loadSFX(1)
Sound.loadSFX(2)
Sound.loadSFX(3)
Sound.loadSFX(4)
   
tmr = Timer.new()  -- temps de jeu 
tmr1 = Timer.new() -- timer pour le monstre 1
tmr2 = Timer.new()
tmr3 = Timer.new()
tmr4 = Timer.new() 
tmr5 = Timer.new()
tmr6 = Timer.new()
tmr:start()

------------------ JEU -------------------
while not Keys.held.Select do
   Controls.read()
   
   --1. Dplacement de la cible
   if Keys.held.Left then     -- sur les cts
      cible.x = cible.x - cible.vitesse
      elseif Keys.held.Right then
         cible.x = cible.x + cible.vitesse
   end
   if Keys.held.Up then       -- en haut et en bas
      cible.y = cible.y - cible.vitesse
      elseif Keys.held.Down then
         cible.y = cible.y + cible.vitesse
   end
   
   if cible.x > 256 then     --Pour que la cible rapparaisse de l'autre ct quand on sort de l'cran
      cible.x = 0
      elseif cible.x + cible.largeur < 0 then   
         cible.x = 256
   end
   if cible.y > 192 then 
      cible.y = 0 
      elseif cible.y + cible.largeur < 0 then 
         cible.y = 192 
   end 
   
   --2. Apparition des ennemis
   if tmr:time() > 0 then 
      ActiveMonstre(1)
      if monstre1.ok then
         if tmr1:time() > 5000 then perdu = true end
      end
   end
   
   if tmr:time() > 5000 then 
      ActiveMonstre(2)
      if monstre2.ok then
         if tmr2:time() > 5000 then perdu = true end
      end
   end
      
   if tmr:time() > 10000 then 
      ActiveMonstre(3)
      if monstre3.ok then
         if tmr3:time() > 5000 then perdu = true end
      end
   end   
      
   if tmr:time() > 15000 then 
      ActiveMonstre(4)
      if monstre4.ok then
         if tmr4:time() > 5000 then perdu = true end
      end
   end   
      
   if tmr:time() > 20000 then 
      ActiveMonstre(5)
      if monstre5.ok then
         if tmr5:time() > 5000 then perdu = true end
      end
   end   
      
   if tmr:time() > 25000 then 
      ActiveMonstre(6)
      if monstre6.ok then
         if tmr6:time() > 5000 then perdu = true end
      end
   end   
   
   --3. Gestion du tir
   if Keys.newPress.A then
      if not perdu and not victoire then
         if munitions > 0 then
            munitions = munitions - 1
            Sound.startSFX(4)    -- Son du tir
            
            if monstre1.ok then
               if cible.x + cible.largeur/2 >= monstre1.x and cible.x + cible.largeur/2 <= monstre1.x + monstre1.largeur and cible.y + cible.hauteur/2 >= monstre1.y and cible.y + cible.hauteur/2 <= monstre1.y + monstre1.hauteur then
                  monstre1.ok = false
                  explosion.x = monstre1.x + 1.5   --pour centrer la tache de sang
                  explosion.y = monstre1.y + 0.5
                  explosion.ok = true
                  Sound.startSFX(3)    --projection de sang
                  tmr1:reset()
                  score = score + 1
               end
            end
            
            
            if monstre2.ok then
               if cible.x + cible.largeur/2 >= monstre2.x and cible.x + cible.largeur/2 <= monstre2.x + monstre2.largeur and cible.y + cible.hauteur/2 >= monstre2.y and cible.y + cible.hauteur/2 <= monstre2.y + monstre2.hauteur then       
                  monstre2.ok = false
                  explosion.x = monstre2.x - 10.5 
                  explosion.y = monstre2.y + 0.5
                  explosion.ok = true
                  Sound.startSFX(3)   --projection de sang
                  tmr2:reset()
                  score = score + 1
               end
            end
            
            if monstre3.ok then
               if cible.x + cible.largeur/2 >= monstre3.x and cible.x + cible.largeur/2 <= monstre3.x + monstre3.largeur and cible.y + cible.hauteur/2 >= monstre3.y and cible.y + cible.hauteur/2 <= monstre3.y + monstre3.hauteur then       
                  monstre3.ok = false
                  explosion.x = monstre3.x - 8.5
                  explosion.y = monstre3.y - 7.5
                  explosion.ok = true
                  Sound.startSFX(3)  --projection de sang
                  tmr3:reset()
                  score = score + 1
               end
            end
            
            if monstre4.ok then
               if cible.x + cible.largeur/2 >= monstre4.x and cible.x + cible.largeur/2 <= monstre4.x + monstre4.largeur and cible.y + cible.hauteur/2 >= monstre4.y and cible.y + cible.hauteur/2 <= monstre4.y + monstre4.hauteur then
                  monstre4.ok = false
                  explosion.x = monstre4.x - 5
                  explosion.y = monstre4.y - 1
                  explosion.ok = true
                  Sound.startSFX(3)  --projection de sang
                  tmr4:reset()
                  score = score + 1
               end
            end
            
            if monstre5.ok then
               if cible.x + cible.largeur/2 >= monstre5.x and cible.x + cible.largeur/2 <= monstre5.x + monstre5.largeur and cible.y + cible.hauteur/2 >= monstre5.y and cible.y + cible.hauteur/2 <= monstre5.y + monstre5.hauteur then
                  monstre5.ok = false
                  explosion.x = monstre5.x - 6.5
                  explosion.y = monstre5.y - 4
                  explosion.ok = true
                  Sound.startSFX(3)  --projection de sang
                  tmr5:reset()
                  score = score + 1
               end
            end
            
            if monstre6.ok then
               if cible.x + cible.largeur/2 >= monstre6.x and cible.x + cible.largeur/2 <= monstre6.x + monstre6.largeur and cible.y + cible.hauteur/2 >= monstre6.y and cible.y + cible.hauteur/2 <= monstre6.y + monstre6.hauteur then   
                  monstre6.ok = false
                  explosion.x = monstre6.x - 4.5
                  explosion.y = monstre6.y -8
                  explosion.ok = true
                  Sound.startSFX(3)  --projection de sang
                  tmr6:reset()
                  score = score + 1
               end
            end
            
            else Sound.startSFX(1)   -- munitions vides
         end
      end
   end
   
   --4. Pour gagner
   if tmr:time() >= 35000 then
      victoire = true
      tmr1:stop()
      tmr2:stop()         
      tmr3:stop()
      tmr4:stop()
      tmr5:stop()
      tmr6:stop()
      
      if victoireAffichage then
         victoireImage = Image.load("images/victoire.png",VRAM)
         victoireAffichage = false
      end   
      if son.victoire then   --  venir
         son.victoire = false
      end
   end
   
   --5. Si on perd
   if perdu then 
      if malus then
         score = score - 5   --on pnalise la dfaite
         malus = false
      end
      if son.croq then
         Sound.startSFX(0)   --bruit de morsure
         son.croq = false
      end
      if son.perdu then
         Sound.startSFX(2)   --rire de femme
         son.perdu = false
      end
      if perduAffichage then
         perduImage = Image.load("images/perdu.png",VRAM)
         perduAffichage = false
      end
   end
   
   --6. Pour rejouer
   if victoire or perdu then
      tmr:stop()
      tmr1:stop()
      tmr2:stop()         
      tmr3:stop()
      tmr4:stop()
      tmr5:stop()
      tmr6:stop()
      if Keys.held.Start then 
         ReinitialiseGame()
      end
   end
   
   -- AFFICHAGE --
   screen.print(SCREEN_DOWN,0,0,"Select pour quitter")
   screen.print(SCREEN_DOWN,0,50,"Temps coul : "..tmr:time()/1000 .."s")
   screen.print(SCREEN_DOWN,0,80,"Munitions : "..munitions)     
   screen.print(SCREEN_DOWN,0,140,"Score : "..score)
   
   if not perdu and not victoire then
      screen.blit(SCREEN_UP,256/2 - Image.width(background)/2,192/2 - Image.height(background)/2,background)
      
      if explosion.ok then screen.blit(SCREEN_UP,explosion.x,explosion.y,explosion.image) end
      if monstre1.ok then screen.blit(SCREEN_UP,monstre1.x,monstre1.y,monstre1.image) end
      if monstre2.ok then screen.blit(SCREEN_UP,monstre2.x,monstre2.y,monstre2.image) end
      if monstre3.ok then screen.blit(SCREEN_UP,monstre3.x,monstre3.y,monstre3.image) end
      if monstre4.ok then screen.blit(SCREEN_UP,monstre4.x,monstre4.y,monstre4.image) end
      if monstre5.ok then screen.blit(SCREEN_UP,monstre5.x,monstre5.y,monstre5.image) end
      if monstre6.ok then screen.blit(SCREEN_UP,monstre6.x,monstre6.y,monstre6.image) end
      
      screen.blit(SCREEN_UP,cible.x,cible.y,cible.image)
      
      elseif perdu then 
         screen.blit(SCREEN_UP,256/2 - Image.width(perduImage)/2,192 - Image.height(perduImage),perduImage) 
         screen.print(SCREEN_DOWN,10,180,"Start pour rejouer")
      elseif victoire then
         screen.blit(SCREEN_UP,0,0,victoireImage) 
         screen.print(SCREEN_DOWN,10,180,"Start pour rejouer")
   end
      
   render()
end
   
-- VIDAGE DE LA MEMOIRE --
Image.destroy(cible.image)  
Image.destroy(background)
Image.destroy(explosion.image)
Image.destroy(monstre1.image)
Image.destroy(monstre2.image)
Image.destroy(monstre3.image)
Image.destroy(monstre4.image)
Image.destroy(monstre5.image)
Image.destroy(monstre6.image)
if perdu then
   Image.destroy(perduImage)
   elseif victoire then
      Image.destroy(victoireImage)
end

Sound.unloadSFX(0)
Sound.unloadSFX(1)
Sound.unloadSFX(2)
Sound.unloadSFX(3)
Sound.unloadSFX(4)
Sound.unloadBank()

cible = nil
background = nil
monstre1, monstre2, monstre3, monstre4, monstre5, monstre6 = nil, nil, nil, nil, nil, nil
explosion = nil
tmr = nil
tmr1, tmr2, tmr3 = nil, nil, nil
tmr4, tmr5, tmr6 = nil, nil, nil
perdu, perduImage = nil, nil, nil
victoire, victoireImage = nil, nil
victoireAffichage, perduAffichage = nil, nil
munitions, score, son, malus  = nil, nil, nil, nil

ActiveMonstre = nil
ReinitialiseGame = nil
